import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates the use of Swing combox boxes.
*/
public class Combo extends JPanel
{
  /**
     No-arg constructor.
  */
  public Combo()
  {
    // The strings that are used as elements of the combo box.
    //
    String [] progLangs = {"Ada", "Algol", "APL", "C", "C++", "Eiffel",
			   "Forth", "Fortran", "Java", "Lisp", "Modula-3", 
			   "Pascal", "PL-1", "Prolog", "Scheme", "Self", 
			   "Smalltalk"};

    // Create the combo box with the set of elements.
    //
    JComboBox cb = new JComboBox(progLangs);

    // Make this combo box editable. The window shows with a white
    // background by default.
    //
    cb.setEditable(true);
    cb.setAlignmentX(Component.LEFT_ALIGNMENT);

    // Set the maximum number of rows of display (not the number of
    // elements that the combo box can hold.
    //
    cb.setMaximumRowCount(20);
    cb.setSelectedIndex(8);

    // Not part of the combo box.  This label appears above the
    // combo box.
    //
    JLabel label = new JLabel("Programming languages");

    Box box = Box.createVerticalBox();

    box.add(label);
    box.add(Box.createRigidArea(new Dimension(0, 10)));
    box.add(cb);
    
    add(box);
  }

  public static void main(String [] args)
  {
    Combo app = new Combo();

    JFrame f = new JFrame("JComboBox Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

}
