import java.awt.*;
import java.io.*;
import javax.swing.*;

public class ProgMonitor extends JFrame
{
  public ProgMonitor()
  {
    super("Progress Monitor Demo");

    JLabel message = new JLabel("This frame will start a ProgressMonitor...");
    message.setHorizontalAlignment(SwingConstants.CENTER);
    getContentPane().add(message, BorderLayout.CENTER);

    progressMonitor = new ProgressMonitor(this, message, note, 0, 100);
    progressMonitor.setProgress(0);
    progressMonitor.setMillisToDecideToPopup(2000);

  }

  public Dimension getPreferredSize()
  {
    return new Dimension(350, 175);
  }

  private void update(int i)
  {
    final int ii = i;

    Runnable updater = new Runnable()
      {
	public void run()
	  {
	    progressMonitor.setProgress(ii);
	    progressMonitor.setNote(note + ii);
	  }
      };
    SwingUtilities.invokeLater(updater);
  }


  private void runTask()
  {
    for (int i = 0; i <= 100; i++)
      {
	try
	  {
	    Thread.sleep(500);
	    update(i);
	  }
	catch(InterruptedException e)
	  {
	  }
      }
  }

  public static void main(String [] args) 
  {
    ProgMonitor app = new ProgMonitor();

    app.pack();
    app.setVisible(true);

    app.runTask();
  }

  ProgressMonitor progressMonitor;

  String note = new String("Currently on iteration number ");

}
