import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class AncestorEventDemo extends JPanel 
{
  public AncestorEventDemo()
  {
    setLayout(new BorderLayout());

    p1 = new JPanel();
    p1.setBorder(BorderFactory.createLineBorder(Color.black, 2));

    JPanel buttons = new JPanel();
    gridLayout = new JButton("Grid Layout");
    borderLayout = new JButton("Border Layout");
    JButton toggle = new JButton("Toggle Visibility");
    buttons.add(toggle);

    AncestorListener aL = new AncestorMonitor();
    p1.addAncestorListener(aL);

    add(buttons, BorderLayout.NORTH);
    add(p1, BorderLayout.CENTER);

    ActionListener actionL = new ActionListener()
      {
	public void actionPerformed(ActionEvent e)
	  {
	    if (p1.isVisible() == true)
	      p1.setVisible(false);
	    else
	      p1.setVisible(true);
	  }
      };
    toggle.addActionListener(actionL);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(375, 125);
  }

  public static void main(String [] args)
  {
    AncestorEventDemo app = new AncestorEventDemo();

    JFrame f = new JFrame("Ancestor Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  JPanel p1;
  JButton gridLayout;
  JButton borderLayout;

}


class AncestorMonitor implements AncestorListener
{
  public void ancestorAdded(AncestorEvent e) 
    {
      System.out.println("Component shown.");
    }

  public void ancestorMoved(AncestorEvent e) 
    {
      System.out.println("Component moved.");;
    }

  public void ancestorRemoved(AncestorEvent e) 
    {
      System.out.println("Component hidden.");
    }
}

