import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;


public class ChangeEventDemo extends JPanel
{
  public ChangeEventDemo()
  {
    JSlider slider = new JSlider(JSlider.HORIZONTAL, 0, 100, 50);
    slider.setPreferredSize(new Dimension(350, 50));
    slider.setSnapToTicks(true);
    slider.setMajorTickSpacing(10);
    slider.setMinorTickSpacing(5);
    slider.setPaintTicks(true);
    slider.setPaintLabels(true);

    ChangeListener cL = new ChangeMonitor();

    // Add a listener for ChangeEvents.  
    slider.addChangeListener(cL);

    add(slider);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(390, 110);
  }

  public static void main(String [] args)
  {
    ChangeEventDemo app = new ChangeEventDemo();

    JFrame f = new JFrame("Change Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);
    
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }


}


class ChangeMonitor implements ChangeListener
{
  public void stateChanged(ChangeEvent e)
  {
    JSlider source = (JSlider) e.getSource();

    if (source.getValueIsAdjusting())
      return;

    System.out.println("Slider value is now " + source.getValue());
  }
}



